/*
 *	fram.c
 *
 *	CHIP/8 - P/ECE CHIP-8 Interpreter
 *
 *	* Mon Mar 22 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define CLUT(c) (c ? 0 : 3)	/* White on Black */
#define CLUT(c) (c ? 3 : 0)	/* Black on White */

void
update_screen(DRIVER* driver)
{
	CHIP8* chip8 = &driver->chip8;
	const unsigned char* src = &chip8->scr[0][0];
	      unsigned char* dst = vbuff;
	int x, y, c;

	if(chip8->stat & CHIP8_SCHIP) {
		/* 128x64: ̂܂ܕ\܂B */
		for(y = 0; y < CHIP8_SCRHI_H; y++) {
			for(x = 0; x < CHIP8_SCRHI_W; x++) {
				c = *src;
				c = CLUT(c);
				*dst = c;
				src++;
				dst++;
			}
		}

	} else {
		/* 64x32[h: c2{Ɋg債ĕ\܂B */
		for(y = 0; y < CHIP8_SCRLO_H; y++) {
			for(x = 0; x < CHIP8_SCRLO_W; x++) {
				c = *src;
				c = CLUT(c);
				dst[                0] = c; dst[                1] = c;
				dst[CHIP8_SCRHI_W + 0] = c; dst[CHIP8_SCRHI_W + 1] = c;
				src += 1;
				dst += 2;
			}
			src += CHIP8_SCRHI_W - CHIP8_SCRLO_W;
			dst += CHIP8_SCRHI_W;
		}
	}
}

