/*	
 *	clipdmg.c
 *
 *	P/ECE DMG-CPU Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Thu Jan 15 20:09:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"
#include "clipdmgi.h"	/*DMGG~[^p}N*/

/****************************************************************************
 *
 ****************************************************************************/

/*
 *	IyR[h}bv
 */
const DMGOP dmg_op_table[256/*XX*/] = {
#include "dmg/xx.h" /* [dmg.xls]XX */
};
const DMGOP dmg_op_table_CB[256/*XX*/] = {
#include "dmg/cb.h" /* [dmg.xls]CB */
};

/*
 *	j[jbNe[u
 */
#undef DMGFN_
#define DMGFN_(OP, FN)	OP "\0"
const char dmg_op_name_table[] = {
	"\0" /* ItZbg0̓k */
#include "dmg/list.h" /* [dmg.xls]List!C5 */
};
#undef DMGFN_

/****************************************************************************
 *
 ****************************************************************************/

void
dmg_reset(DMG* dmg, DMGREADPROC* read, DMGWRITEPROC* write)
{
	memset(dmg, 0, sizeof(DMG));
	dmg->read  = read  ? read  : dmg_internal_read;
	dmg->write = write ? write : dmg_internal_write;
}

void
dmg_int(DMG* dmg, unsigned short addr)
{
	if(!IME) return;
	PUSH(PC);
	PC = addr;
	IME = 0;
	HALT = 0;
}

void
dmg_dump(DMG* dmg)
{
#define INDENT	40
	TRACE("%*s", INDENT, "");
	TRACE("F:%c%c%c%c%c%c%c%c A:%02x BC:%04x DE:%04x HL:%04x SP:%04x PC:%04x\n",
		LO(AF) & (1 << 7) ? 'Z' : '-',
		LO(AF) & (1 << 6) ? 'N' : '-',
		LO(AF) & (1 << 5) ? 'H' : '-',
		LO(AF) & (1 << 4) ? 'C' : '-',
		LO(AF) & (1 << 3) ? '1' : '0', /* 0ŒB1ɂȂoOł */
		LO(AF) & (1 << 2) ? '1' : '0', /* 0ŒB1ɂȂoOł */
		LO(AF) & (1 << 1) ? '1' : '0', /* 0ŒB1ɂȂoOł */
		LO(AF) & (1 << 0) ? '1' : '0', /* 0ŒB1ɂȂoOł */
		HI(AF), BC, DE, HL, SP, PC);
#undef INDENT
}

/****************************************************************************
 *
 ****************************************************************************/

#ifdef PIECE

asm("
	.code
	.global dmg_run2
dmg_run2:
	pushn %r0
	ld.w %r0, %sp		; X^bNޔ
	xld.w %r10, 0x1000	; 0x0e00`0x1000ɃX^bNؑ
	ld.w %sp, %r10
	xcall dmg_run
	ld.w %sp, %r0		; X^bN
	popn %r0
	ret
");

#endif /*PIECE*/

/****************************************************************************
 *
 ****************************************************************************/

