/*	
 *	clipspr.c
 *
 *	ȈՃXvCghCo`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sat Apr 24 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/*****************************************************************************
 *	
 *****************************************************************************/

typedef struct _SPRITE_DRIVER {
	RENDER* render;
	const SPRITE* sprites/*[sprite_count]*/;
	int sprite_count;
	TEXTURE* textures/*[texture_count]*/;
	int texture_count;
} SPRITE_DRIVER;

static SPRITE_DRIVER sprite_driver;

/*****************************************************************************
 *	
 *****************************************************************************/

void
sprite_init(RENDER* render,
	const SPRITE* sprites/*[sprite_count]*/, int sprite_count,
	TEXTURE* textures/*[texture_count]*/, int texture_count)
{
	SPRITE_DRIVER* driver = &sprite_driver;

	memset(driver, 0, sizeof sprite_driver);
	driver->render = render;
	driver->sprites = sprites;
	driver->sprite_count = sprite_count;
	driver->textures = textures;
	driver->texture_count = texture_count;
}

void
sprite_draw(int x, int y, int sprno, int param)
{
	SPRITE_DRIVER* driver = &sprite_driver;
	RENDER* render = driver->render;
	//
	const SPRITE* sprite;
	TEXTURE* texture_save;

	/* ̂߁Arender_save()g킸ɃeNX`ޔ܂B */
	texture_save = render->context->texture;

	/* XvCg擾܂B */
	if(sprno < 0 || driver->sprite_count - 1 < sprno) DIE();
	sprite = &driver->sprites[sprno];

	/* eNX`ݒ肵܂B */
	if(sprite->texno > driver->texture_count - 1) DIE();
	render->context->texture = &driver->textures[sprite->texno];

	/* XvCg`܂B */
	param ^= sprite->param;
	if(!(param & DRW_REVX)) {
		x -= sprite->cx;
	} else {
		x += sprite->cx - sprite->w + 1;
	}
	if(!(param & DRW_REVY)) {
		y -= sprite->cy;
	} else {
		y += sprite->cy - sprite->h + 1;
	}
	render_object(render, x, y, sprite->x, sprite->y, sprite->w, sprite->h, param);

	/* ̂߁Arender_restore()g킸ɃeNX`܂B */
	render->context->texture = texture_save;
}

